#line 1 "C:/Users/katarina.perendic/Desktop/Color_7_example/basic/color7_mm_example_driver.c"
#line 1 "c:/users/katarina.perendic/desktop/color_7_example/basic/color7_mm_example_objects.h"
typedef struct Screen TScreen;

typedef struct Label {
 TScreen* OwnerScreen;
 char Order;
 unsigned int Left;
 unsigned int Top;
 unsigned int Width;
 unsigned int Height;
 char *Caption;
 const char *FontName;
 unsigned int Font_Color;
 char VerticalText;
 char Visible;
 char Active;
 void (*OnUpPtr)();
 void (*OnDownPtr)();
 void (*OnClickPtr)();
 void (*OnPressPtr)();
} TLabel;

typedef struct Circle {
 TScreen* OwnerScreen;
 char Order;
 unsigned int Left;
 unsigned int Top;
 unsigned int Radius;
 char Pen_Width;
 unsigned int Pen_Color;
 char Visible;
 char Active;
 char Transparent;
 char Gradient;
 char Gradient_Orientation;
 unsigned int Gradient_Start_Color;
 unsigned int Gradient_End_Color;
 unsigned int Color;
 char PressColEnabled;
 unsigned int Press_Color;
 void (*OnUpPtr)();
 void (*OnDownPtr)();
 void (*OnClickPtr)();
 void (*OnPressPtr)();
} TCircle;

typedef struct Box {
 TScreen* OwnerScreen;
 char Order;
 unsigned int Left;
 unsigned int Top;
 unsigned int Width;
 unsigned int Height;
 char Pen_Width;
 unsigned int Pen_Color;
 char Visible;
 char Active;
 char Transparent;
 char Gradient;
 char Gradient_Orientation;
 unsigned int Gradient_Start_Color;
 unsigned int Gradient_End_Color;
 unsigned int Color;
 char PressColEnabled;
 unsigned int Press_Color;
 void (*OnUpPtr)();
 void (*OnDownPtr)();
 void (*OnClickPtr)();
 void (*OnPressPtr)();
} TBox;

typedef struct Line {
 TScreen* OwnerScreen;
 char Order;
 unsigned int First_Point_X;
 unsigned int First_Point_Y;
 unsigned int Second_Point_X;
 unsigned int Second_Point_Y;
 char Pen_Width;
 char Visible;
 unsigned int Color;
} TLine;

struct Screen {
 unsigned int Color;
 unsigned int Width;
 unsigned int Height;
 unsigned int ObjectsCount;
 unsigned int LabelsCount;
 TLabel * const code *Labels;
 unsigned int CirclesCount;
 TCircle * const code *Circles;
 unsigned int BoxesCount;
 TBox * const code *Boxes;
 unsigned int LinesCount;
 TLine * const code *Lines;
};

extern TScreen Screen1;
extern TCircle Color_circle;
extern TLine Line1;
extern TLine Line2;
extern TLabel Label1;
extern TLabel Label2;
extern TLabel Label3;
extern TBox Box1;
extern TBox Box2;
extern TBox Box3;
extern TLabel Label4;
extern TBox Box4;
extern TLabel Label5;
extern TLabel Label6;
extern TLabel Label7;
extern TLabel HSL_value;
extern TLabel Blue_value;
extern TLabel Green_value;
extern TLabel Red_value;
extern TLabel * const code Screen1_Labels[11];
extern TCircle * const code Screen1_Circles[1];
extern TBox * const code Screen1_Boxes[4];
extern TLine * const code Screen1_Lines[2];








extern char Color_circle_Caption[];
extern char Line1_Caption[];
extern char Line2_Caption[];
extern char Label1_Caption[];
extern char Label2_Caption[];
extern char Label3_Caption[];
extern char Box1_Caption[];
extern char Box2_Caption[];
extern char Box3_Caption[];
extern char Label4_Caption[];
extern char Box4_Caption[];
extern char Label5_Caption[];
extern char Label6_Caption[];
extern char Label7_Caption[];
extern char HSL_value_Caption[];
extern char Blue_value_Caption[];
extern char Green_value_Caption[];
extern char Red_value_Caption[];


void DrawScreen(TScreen *aScreen);
void DrawLabel(TLabel *ALabel);
void DrawCircle(TCircle *ACircle, int color);
void DrawBox(TBox *ABox);
void DrawLine(TLine *Aline);
void Check_TP();
void Start_TP();
#line 1 "c:/users/katarina.perendic/desktop/color_7_example/basic/color7_mm_example_resources.h"
const code char Tahoma12x16_Regular[];
const code char Tahoma19x19_Bold[];
const code char Tahoma23x23_Bold[];
const code char Tahoma11x13_Regular[];
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for arm/include/built_in.h"
#line 7 "C:/Users/katarina.perendic/Desktop/Color_7_example/basic/color7_mm_example_driver.c"
sbit TFT_BLED at GPIOE_ODR.B9;
sbit TFT_CS at GPIOE_ODR.B15;
unsigned int TFT_DataPort at GPIOE_ODR;
sbit TFT_RD at GPIOE_ODR.B10;
sbit TFT_RS at GPIOE_ODR.B12;
sbit TFT_RST at GPIOE_ODR.B8;
sbit TFT_WR at GPIOE_ODR.B11;



sbit DriveX_Left at GPIOB_ODR.B1;
sbit DriveX_Right at GPIOB_ODR.B8;
sbit DriveY_Up at GPIOB_ODR.B9;
sbit DriveY_Down at GPIOB_ODR.B0;



unsigned int Xcoord, Ycoord;
const ADC_THRESHOLD = 1500;
char PenDown;
void *PressedObject;
int PressedObjectType;
unsigned int caption_length, caption_height;
unsigned int display_width, display_height;

int _object_count;
unsigned short object_pressed;
TLabel *local_label;
TLabel *exec_label;
int label_order;
TCircle *local_circle;
TCircle *exec_circle;
int circle_order;
TBox *local_box;
TBox *exec_box;
int box_order;

static void InitializeTouchPanel() {
 TFT_Init_ILI9341_8bit(320, 240);

}



 TScreen* CurrentScreen;

 TScreen Screen1;
 TCircle Color_circle;
 TLine Line1;
 TLine Line2;
 TLabel Label1;
char Label1_Caption[10] = "Red Ratio";

 TLabel Label2;
char Label2_Caption[12] = "Green Ratio";

 TLabel Label3;
char Label3_Caption[11] = "Blue Ratio";

 TBox Box1;
 TBox Box2;
 TBox Box3;
 TLabel Label4;
char Label4_Caption[6] = "Color";

 TBox Box4;
 TLabel Label5;
char Label5_Caption[16] = "HSL color value";

 TLabel Label6;
char Label6_Caption[15] = "www.mikroe.com";

 TLabel Label7;
char Label7_Caption[14] = "Color 7 click";

 TLabel HSL_value;
char HSL_value_Caption[5] = "0.00";

 TLabel Blue_value;
char Blue_value_Caption[5] = "0.00";

 TLabel Green_value;
char Green_value_Caption[5] = "0.00";

 TLabel Red_value;
char Red_value_Caption[5] = "0.00";

 TLabel * const code Screen1_Labels[11]=
 {
 &Label1,
 &Label2,
 &Label3,
 &Label4,
 &Label5,
 &Label6,
 &Label7,
 &HSL_value,
 &Blue_value,
 &Green_value,
 &Red_value
 };
 TCircle * const code Screen1_Circles[1]=
 {
 &Color_circle
 };
 TBox * const code Screen1_Boxes[4]=
 {
 &Box1,
 &Box2,
 &Box3,
 &Box4
 };
 TLine * const code Screen1_Lines[2]=
 {
 &Line1,
 &Line2
 };



static void InitializeObjects() {
 Screen1.Color = 0xFFFF;
 Screen1.Width = 320;
 Screen1.Height = 240;
 Screen1.LabelsCount = 11;
 Screen1.Labels = Screen1_Labels;
 Screen1.CirclesCount = 1;
 Screen1.Circles = Screen1_Circles;
 Screen1.BoxesCount = 4;
 Screen1.Boxes = Screen1_Boxes;
 Screen1.LinesCount = 2;
 Screen1.Lines = Screen1_Lines;
 Screen1.ObjectsCount = 18;


 Color_circle.OwnerScreen = &Screen1;
 Color_circle.Order = 0;
 Color_circle.Left = 206;
 Color_circle.Top = 50;
 Color_circle.Radius = 45;
 Color_circle.Pen_Width = 0;
 Color_circle.Pen_Color = 0xFFFF;
 Color_circle.Visible = 1;
 Color_circle.Active = 1;
 Color_circle.Transparent = 1;
 Color_circle.Gradient = 1;
 Color_circle.Gradient_Orientation = 0;
 Color_circle.Gradient_Start_Color = 0x9CD3;
 Color_circle.Gradient_End_Color = 0x9CD3;
 Color_circle.Color = 0x9CD3;
 Color_circle.PressColEnabled = 1;
 Color_circle.Press_Color = 0xE71C;
 Color_circle.OnUpPtr = 0;
 Color_circle.OnDownPtr = 0;
 Color_circle.OnClickPtr = 0;
 Color_circle.OnPressPtr = 0;

 Line1.OwnerScreen = &Screen1;
 Line1.Order = 1;
 Line1.First_Point_X = 1;
 Line1.First_Point_Y = 22;
 Line1.Second_Point_X = 321;
 Line1.Second_Point_Y = 22;
 Line1.Visible = 1;
 Line1.Pen_Width = 1;
 Line1.Color = 0x0000;

 Line2.OwnerScreen = &Screen1;
 Line2.Order = 2;
 Line2.First_Point_X = 0;
 Line2.First_Point_Y = 219;
 Line2.Second_Point_X = 319;
 Line2.Second_Point_Y = 219;
 Line2.Visible = 1;
 Line2.Pen_Width = 1;
 Line2.Color = 0x0000;

 Label1.OwnerScreen = &Screen1;
 Label1.Order = 3;
 Label1.Left = 6;
 Label1.Top = 30;
 Label1.Width = 86;
 Label1.Height = 21;
 Label1.Visible = 1;
 Label1.Active = 1;
 Label1.Caption = Label1_Caption;
 Label1.FontName = Tahoma19x19_Bold;
 Label1.Font_Color = 0xF800;
 Label1.VerticalText = 0;
 Label1.OnUpPtr = 0;
 Label1.OnDownPtr = 0;
 Label1.OnClickPtr = 0;
 Label1.OnPressPtr = 0;

 Label2.OwnerScreen = &Screen1;
 Label2.Order = 4;
 Label2.Left = 7;
 Label2.Top = 86;
 Label2.Width = 104;
 Label2.Height = 21;
 Label2.Visible = 1;
 Label2.Active = 1;
 Label2.Caption = Label2_Caption;
 Label2.FontName = Tahoma19x19_Bold;
 Label2.Font_Color = 0x34C0;
 Label2.VerticalText = 0;
 Label2.OnUpPtr = 0;
 Label2.OnDownPtr = 0;
 Label2.OnClickPtr = 0;
 Label2.OnPressPtr = 0;

 Label3.OwnerScreen = &Screen1;
 Label3.Order = 5;
 Label3.Left = 7;
 Label3.Top = 142;
 Label3.Width = 91;
 Label3.Height = 21;
 Label3.Visible = 1;
 Label3.Active = 1;
 Label3.Caption = Label3_Caption;
 Label3.FontName = Tahoma19x19_Bold;
 Label3.Font_Color = 0x001F;
 Label3.VerticalText = 0;
 Label3.OnUpPtr = 0;
 Label3.OnDownPtr = 0;
 Label3.OnClickPtr = 0;
 Label3.OnPressPtr = 0;

 Box1.OwnerScreen = &Screen1;
 Box1.Order = 6;
 Box1.Left = 8;
 Box1.Top = 51;
 Box1.Width = 140;
 Box1.Height = 33;
 Box1.Pen_Width = 1;
 Box1.Pen_Color = 0xF800;
 Box1.Visible = 1;
 Box1.Active = 1;
 Box1.Transparent = 1;
 Box1.Gradient = 1;
 Box1.Gradient_Orientation = 0;
 Box1.Gradient_Start_Color = 0xFFFF;
 Box1.Gradient_End_Color = 0xFFFF;
 Box1.Color = 0xFFFF;
 Box1.PressColEnabled = 1;
 Box1.Press_Color = 0xE71C;
 Box1.OnUpPtr = 0;
 Box1.OnDownPtr = 0;
 Box1.OnClickPtr = 0;
 Box1.OnPressPtr = 0;

 Box2.OwnerScreen = &Screen1;
 Box2.Order = 7;
 Box2.Left = 9;
 Box2.Top = 107;
 Box2.Width = 140;
 Box2.Height = 33;
 Box2.Pen_Width = 1;
 Box2.Pen_Color = 0x34C0;
 Box2.Visible = 1;
 Box2.Active = 1;
 Box2.Transparent = 1;
 Box2.Gradient = 1;
 Box2.Gradient_Orientation = 0;
 Box2.Gradient_Start_Color = 0xFFFF;
 Box2.Gradient_End_Color = 0xFFFF;
 Box2.Color = 0xFFFF;
 Box2.PressColEnabled = 1;
 Box2.Press_Color = 0xE71C;
 Box2.OnUpPtr = 0;
 Box2.OnDownPtr = 0;
 Box2.OnClickPtr = 0;
 Box2.OnPressPtr = 0;

 Box3.OwnerScreen = &Screen1;
 Box3.Order = 8;
 Box3.Left = 9;
 Box3.Top = 165;
 Box3.Width = 140;
 Box3.Height = 33;
 Box3.Pen_Width = 1;
 Box3.Pen_Color = 0x001F;
 Box3.Visible = 1;
 Box3.Active = 1;
 Box3.Transparent = 1;
 Box3.Gradient = 1;
 Box3.Gradient_Orientation = 0;
 Box3.Gradient_Start_Color = 0xFFFF;
 Box3.Gradient_End_Color = 0xFFFF;
 Box3.Color = 0xFFFF;
 Box3.PressColEnabled = 1;
 Box3.Press_Color = 0xE71C;
 Box3.OnUpPtr = 0;
 Box3.OnDownPtr = 0;
 Box3.OnClickPtr = 0;
 Box3.OnPressPtr = 0;

 Label4.OwnerScreen = &Screen1;
 Label4.Order = 9;
 Label4.Left = 173;
 Label4.Top = 33;
 Label4.Width = 58;
 Label4.Height = 25;
 Label4.Visible = 1;
 Label4.Active = 1;
 Label4.Caption = Label4_Caption;
 Label4.FontName = Tahoma23x23_Bold;
 Label4.Font_Color = 0x0000;
 Label4.VerticalText = 0;
 Label4.OnUpPtr = 0;
 Label4.OnDownPtr = 0;
 Label4.OnClickPtr = 0;
 Label4.OnPressPtr = 0;

 Box4.OwnerScreen = &Screen1;
 Box4.Order = 10;
 Box4.Left = 164;
 Box4.Top = 176;
 Box4.Width = 140;
 Box4.Height = 33;
 Box4.Pen_Width = 1;
 Box4.Pen_Color = 0xF81F;
 Box4.Visible = 1;
 Box4.Active = 1;
 Box4.Transparent = 1;
 Box4.Gradient = 1;
 Box4.Gradient_Orientation = 0;
 Box4.Gradient_Start_Color = 0xFFFF;
 Box4.Gradient_End_Color = 0xFFFF;
 Box4.Color = 0xFFFF;
 Box4.PressColEnabled = 1;
 Box4.Press_Color = 0xE71C;
 Box4.OnUpPtr = 0;
 Box4.OnDownPtr = 0;
 Box4.OnClickPtr = 0;
 Box4.OnPressPtr = 0;

 Label5.OwnerScreen = &Screen1;
 Label5.Order = 11;
 Label5.Left = 167;
 Label5.Top = 155;
 Label5.Width = 133;
 Label5.Height = 21;
 Label5.Visible = 1;
 Label5.Active = 1;
 Label5.Caption = Label5_Caption;
 Label5.FontName = Tahoma19x19_Bold;
 Label5.Font_Color = 0xF81F;
 Label5.VerticalText = 0;
 Label5.OnUpPtr = 0;
 Label5.OnDownPtr = 0;
 Label5.OnClickPtr = 0;
 Label5.OnPressPtr = 0;

 Label6.OwnerScreen = &Screen1;
 Label6.Order = 12;
 Label6.Left = 221;
 Label6.Top = 224;
 Label6.Width = 91;
 Label6.Height = 15;
 Label6.Visible = 1;
 Label6.Active = 1;
 Label6.Caption = Label6_Caption;
 Label6.FontName = Tahoma11x13_Regular;
 Label6.Font_Color = 0xF800;
 Label6.VerticalText = 0;
 Label6.OnUpPtr = 0;
 Label6.OnDownPtr = 0;
 Label6.OnClickPtr = 0;
 Label6.OnPressPtr = 0;

 Label7.OwnerScreen = &Screen1;
 Label7.Order = 13;
 Label7.Left = 102;
 Label7.Top = 3;
 Label7.Width = 106;
 Label7.Height = 21;
 Label7.Visible = 1;
 Label7.Active = 1;
 Label7.Caption = Label7_Caption;
 Label7.FontName = Tahoma19x19_Bold;
 Label7.Font_Color = 0x0000;
 Label7.VerticalText = 0;
 Label7.OnUpPtr = 0;
 Label7.OnDownPtr = 0;
 Label7.OnClickPtr = 0;
 Label7.OnPressPtr = 0;

 HSL_value.OwnerScreen = &Screen1;
 HSL_value.Order = 14;
 HSL_value.Left = 171;
 HSL_value.Top = 186;
 HSL_value.Width = 30;
 HSL_value.Height = 17;
 HSL_value.Visible = 1;
 HSL_value.Active = 1;
 HSL_value.Caption = HSL_value_Caption;
 HSL_value.FontName = Tahoma12x16_Regular;
 HSL_value.Font_Color = 0x0000;
 HSL_value.VerticalText = 0;
 HSL_value.OnUpPtr = 0;
 HSL_value.OnDownPtr = 0;
 HSL_value.OnClickPtr = 0;
 HSL_value.OnPressPtr = 0;

 Blue_value.OwnerScreen = &Screen1;
 Blue_value.Order = 15;
 Blue_value.Left = 14;
 Blue_value.Top = 173;
 Blue_value.Width = 30;
 Blue_value.Height = 17;
 Blue_value.Visible = 1;
 Blue_value.Active = 1;
 Blue_value.Caption = Blue_value_Caption;
 Blue_value.FontName = Tahoma12x16_Regular;
 Blue_value.Font_Color = 0x0000;
 Blue_value.VerticalText = 0;
 Blue_value.OnUpPtr = 0;
 Blue_value.OnDownPtr = 0;
 Blue_value.OnClickPtr = 0;
 Blue_value.OnPressPtr = 0;

 Green_value.OwnerScreen = &Screen1;
 Green_value.Order = 16;
 Green_value.Left = 15;
 Green_value.Top = 115;
 Green_value.Width = 30;
 Green_value.Height = 17;
 Green_value.Visible = 1;
 Green_value.Active = 1;
 Green_value.Caption = Green_value_Caption;
 Green_value.FontName = Tahoma12x16_Regular;
 Green_value.Font_Color = 0x0000;
 Green_value.VerticalText = 0;
 Green_value.OnUpPtr = 0;
 Green_value.OnDownPtr = 0;
 Green_value.OnClickPtr = 0;
 Green_value.OnPressPtr = 0;

 Red_value.OwnerScreen = &Screen1;
 Red_value.Order = 17;
 Red_value.Left = 13;
 Red_value.Top = 59;
 Red_value.Width = 30;
 Red_value.Height = 17;
 Red_value.Visible = 1;
 Red_value.Active = 1;
 Red_value.Caption = Red_value_Caption;
 Red_value.FontName = Tahoma12x16_Regular;
 Red_value.Font_Color = 0x0000;
 Red_value.VerticalText = 0;
 Red_value.OnUpPtr = 0;
 Red_value.OnDownPtr = 0;
 Red_value.OnClickPtr = 0;
 Red_value.OnPressPtr = 0;
}

static char IsInsideObject (unsigned int X, unsigned int Y, unsigned int Left, unsigned int Top, unsigned int Width, unsigned int Height) {
 if ( (Left<= X) && (Left+ Width - 1 >= X) &&
 (Top <= Y) && (Top + Height - 1 >= Y) )
 return 1;
 else
 return 0;
}








void DrawLabel(TLabel *ALabel) {
 if (ALabel->Visible != 0) {
 if (ALabel->VerticalText != 0)
 TFT_Set_Font(ALabel->FontName, ALabel->Font_Color, FO_VERTICAL_COLUMN);
 else
 TFT_Set_Font(ALabel->FontName, ALabel->Font_Color, FO_HORIZONTAL);
 TFT_Write_Text(ALabel->Caption, ALabel->Left, ALabel->Top);
 }
}

void DrawCircle(TCircle *ACircle, int color) {
 if (ACircle->Visible != 0) {
 if (object_pressed == 1) {
 object_pressed = 0;
 TFT_Set_Brush(1, 0xE71C,1, 0,color, color);
 }
 else {
 TFT_Set_Brush(1, 0xE71C,1, 0,color, color);
 }
 TFT_Set_Pen(ACircle->Pen_Color, ACircle->Pen_Width);
 TFT_Circle(ACircle->Left + ACircle->Radius,
 ACircle->Top + ACircle->Radius,
 ACircle->Radius);
 }
}

void DrawBox(TBox *ABox) {
 if (ABox->Visible != 0) {
 if (object_pressed == 1) {
 object_pressed = 0;
 TFT_Set_Brush(ABox->Transparent, ABox->Press_Color, ABox->Gradient, ABox->Gradient_Orientation, ABox->Gradient_End_Color, ABox->Gradient_Start_Color);
 }
 else {
 TFT_Set_Brush(ABox->Transparent, ABox->Color, ABox->Gradient, ABox->Gradient_Orientation, ABox->Gradient_Start_Color, ABox->Gradient_End_Color);
 }
 TFT_Set_Pen(ABox->Pen_Color, ABox->Pen_Width);
 TFT_Rectangle(ABox->Left, ABox->Top, ABox->Left + ABox->Width - 1, ABox->Top + ABox->Height - 1);
 }
}

void DrawLine(TLine *Aline) {
 if (Aline->Visible != 0) {
 TFT_Set_Pen(Aline->Color, Aline->Pen_Width);
 TFT_Line(Aline->First_Point_X, Aline->First_Point_Y, Aline->Second_Point_X, Aline->Second_Point_Y);
 }
}

void DrawScreen(TScreen *aScreen) {
 unsigned int order;
 unsigned short label_idx;
 TLabel *local_label;
 unsigned short circle_idx;
 TCircle *local_circle;
 unsigned short box_idx;
 TBox *local_box;
 unsigned short line_idx;
 TLine *local_line;
 char save_bled;

 object_pressed = 0;
 order = 0;
 label_idx = 0;
 circle_idx = 0;
 box_idx = 0;
 line_idx = 0;
 CurrentScreen = aScreen;

 if ((display_width != CurrentScreen->Width) || (display_height != CurrentScreen->Height)) {
 save_bled = TFT_BLED;
 TFT_BLED = 0;
 TFT_Init_ILI9341_8bit(CurrentScreen->Width, CurrentScreen->Height);
 TFT_Fill_Screen(CurrentScreen->Color);
 display_width = CurrentScreen->Width;
 display_height = CurrentScreen->Height;
 TFT_BLED = save_bled;
 }
 else
 TFT_Fill_Screen(CurrentScreen->Color);


 while (order < CurrentScreen->ObjectsCount) {
 if (label_idx < CurrentScreen->LabelsCount) {
 local_label =  CurrentScreen->Labels[label_idx] ;
 if (order == local_label->Order) {
 label_idx++;
 order++;
 DrawLabel(local_label);
 }
 }

 if (circle_idx < CurrentScreen->CirclesCount) {
 local_circle =  CurrentScreen->Circles[circle_idx] ;
 if (order == local_circle->Order) {
 circle_idx++;
 order++;
 DrawCircle(local_circle, 0xE71C);
 }
 }

 if (box_idx < CurrentScreen->BoxesCount) {
 local_box =  CurrentScreen->Boxes[box_idx] ;
 if (order == local_box->Order) {
 box_idx++;
 order++;
 DrawBox(local_box);
 }
 }

 if (line_idx < CurrentScreen->LinesCount) {
 local_line =  CurrentScreen->Lines[line_idx] ;
 if (order == local_line->Order) {
 line_idx++;
 order++;
 DrawLine(local_line);
 }
 }

 }
}

void Init_MCU() {
 GPIO_Digital_Output(&GPIOE_BASE, _GPIO_PINMASK_9);
 TFT_BLED = 1;
 TFT_Set_Default_Mode();
}

void Start_TP() {
 Init_MCU();

 InitializeTouchPanel();
 InitializeObjects();
 display_width = Screen1.Width;
 display_height = Screen1.Height;
 DrawScreen(&Screen1);
}
