#line 1 "C:/Users/katarina.perendic/Desktop/Color_7_example/basic/color7_mm_example_main.c"
#line 1 "c:/users/katarina.perendic/desktop/color_7_example/basic/color7_mm_example_objects.h"
typedef struct Screen TScreen;

typedef struct Label {
 TScreen* OwnerScreen;
 char Order;
 unsigned int Left;
 unsigned int Top;
 unsigned int Width;
 unsigned int Height;
 char *Caption;
 const char *FontName;
 unsigned int Font_Color;
 char VerticalText;
 char Visible;
 char Active;
 void (*OnUpPtr)();
 void (*OnDownPtr)();
 void (*OnClickPtr)();
 void (*OnPressPtr)();
} TLabel;

typedef struct Circle {
 TScreen* OwnerScreen;
 char Order;
 unsigned int Left;
 unsigned int Top;
 unsigned int Radius;
 char Pen_Width;
 unsigned int Pen_Color;
 char Visible;
 char Active;
 char Transparent;
 char Gradient;
 char Gradient_Orientation;
 unsigned int Gradient_Start_Color;
 unsigned int Gradient_End_Color;
 unsigned int Color;
 char PressColEnabled;
 unsigned int Press_Color;
 void (*OnUpPtr)();
 void (*OnDownPtr)();
 void (*OnClickPtr)();
 void (*OnPressPtr)();
} TCircle;

typedef struct Box {
 TScreen* OwnerScreen;
 char Order;
 unsigned int Left;
 unsigned int Top;
 unsigned int Width;
 unsigned int Height;
 char Pen_Width;
 unsigned int Pen_Color;
 char Visible;
 char Active;
 char Transparent;
 char Gradient;
 char Gradient_Orientation;
 unsigned int Gradient_Start_Color;
 unsigned int Gradient_End_Color;
 unsigned int Color;
 char PressColEnabled;
 unsigned int Press_Color;
 void (*OnUpPtr)();
 void (*OnDownPtr)();
 void (*OnClickPtr)();
 void (*OnPressPtr)();
} TBox;

typedef struct Line {
 TScreen* OwnerScreen;
 char Order;
 unsigned int First_Point_X;
 unsigned int First_Point_Y;
 unsigned int Second_Point_X;
 unsigned int Second_Point_Y;
 char Pen_Width;
 char Visible;
 unsigned int Color;
} TLine;

struct Screen {
 unsigned int Color;
 unsigned int Width;
 unsigned int Height;
 unsigned int ObjectsCount;
 unsigned int LabelsCount;
 TLabel * const code *Labels;
 unsigned int CirclesCount;
 TCircle * const code *Circles;
 unsigned int BoxesCount;
 TBox * const code *Boxes;
 unsigned int LinesCount;
 TLine * const code *Lines;
};

extern TScreen Screen1;
extern TCircle Color_circle;
extern TLine Line1;
extern TLine Line2;
extern TLabel Label1;
extern TLabel Label2;
extern TLabel Label3;
extern TBox Box1;
extern TBox Box2;
extern TBox Box3;
extern TLabel Label4;
extern TBox Box4;
extern TLabel Label5;
extern TLabel Label6;
extern TLabel Label7;
extern TLabel HSL_value;
extern TLabel Blue_value;
extern TLabel Green_value;
extern TLabel Red_value;
extern TLabel * const code Screen1_Labels[11];
extern TCircle * const code Screen1_Circles[1];
extern TBox * const code Screen1_Boxes[4];
extern TLine * const code Screen1_Lines[2];








extern char Color_circle_Caption[];
extern char Line1_Caption[];
extern char Line2_Caption[];
extern char Label1_Caption[];
extern char Label2_Caption[];
extern char Label3_Caption[];
extern char Box1_Caption[];
extern char Box2_Caption[];
extern char Box3_Caption[];
extern char Label4_Caption[];
extern char Box4_Caption[];
extern char Label5_Caption[];
extern char Label6_Caption[];
extern char Label7_Caption[];
extern char HSL_value_Caption[];
extern char Blue_value_Caption[];
extern char Green_value_Caption[];
extern char Red_value_Caption[];


void DrawScreen(TScreen *aScreen);
void DrawLabel(TLabel *ALabel);
void DrawCircle(TCircle *ACircle, int color);
void DrawBox(TBox *ABox);
void DrawLine(TLine *Aline);
void Check_TP();
void Start_TP();
#line 1 "c:/users/katarina.perendic/desktop/color_7_example/basic/color7_mm_example_resources.h"
const code char Tahoma12x16_Regular[];
const code char Tahoma19x19_Bold[];
const code char Tahoma23x23_Bold[];
const code char Tahoma11x13_Regular[];
#line 1 "c:/users/katarina.perendic/desktop/color_7_example/basic/demo_types.h"
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for arm/include/stdint.h"





typedef signed char int8_t;
typedef signed int int16_t;
typedef signed long int int32_t;
typedef signed long long int64_t;


typedef unsigned char uint8_t;
typedef unsigned int uint16_t;
typedef unsigned long int uint32_t;
typedef unsigned long long uint64_t;


typedef signed char int_least8_t;
typedef signed int int_least16_t;
typedef signed long int int_least32_t;
typedef signed long long int_least64_t;


typedef unsigned char uint_least8_t;
typedef unsigned int uint_least16_t;
typedef unsigned long int uint_least32_t;
typedef unsigned long long uint_least64_t;



typedef signed long int int_fast8_t;
typedef signed long int int_fast16_t;
typedef signed long int int_fast32_t;
typedef signed long long int_fast64_t;


typedef unsigned long int uint_fast8_t;
typedef unsigned long int uint_fast16_t;
typedef unsigned long int uint_fast32_t;
typedef unsigned long long uint_fast64_t;


typedef signed long int intptr_t;
typedef unsigned long int uintptr_t;


typedef signed long long intmax_t;
typedef unsigned long long uintmax_t;
#line 1 "c:/users/katarina.perendic/desktop/color_7_example/basic/demo_config.h"
#line 1 "c:/users/katarina.perendic/desktop/color_7_example/basic/demo_types.h"
#line 3 "c:/users/katarina.perendic/desktop/color_7_example/basic/demo_config.h"
const uint32_t _COLOR7_I2C_CFG[ 1 ] =
{
 100000
};

const uint32_t _LEDDRIVER3_I2C_CFG[ 1 ] =
{
 100000
};
#line 21 "C:/Users/katarina.perendic/Desktop/Color_7_example/basic/color7_mm_example_main.c"
float isColor;
float colorValue;
char hslData_text[ 20 ] = "0.00";
char redData_text[ 20 ] = "0.00";
char greenData_text[ 20 ] = "0.00";
char blueData_text[ 20 ] = "0.00";

float redRatio = 0;
float greenRatio = 0;
float blueRatio = 0;

void systemInit()
{
 mikrobus_gpioInit( _MIKROBUS1, _MIKROBUS_INT_PIN, _GPIO_INPUT );
 mikrobus_i2cInit( _MIKROBUS1, &_COLOR7_I2C_CFG[0] );
 mikrobus_i2cInit( _MIKROBUS2, &_LEDDRIVER3_I2C_CFG[0] );
 mikrobus_logInit( _LOG_USBUART_A, 9600 );
 mikrobus_logWrite("--- System init --- ", _LOG_LINE);
 Delay_ms( 100 );
}

void applicationInit()
{
 color7_i2cDriverInit( ( const uint8_t* )&_MIKROBUS1_GPIO, ( const uint8_t* )&_MIKROBUS1_I2C, 0x29 );
 leddriver3_i2cDriverInit( ( const uint8_t* )&_MIKROBUS2_GPIO, ( const uint8_t* )&_MIKROBUS2_I2C, 0x38 );

 mikrobus_logWrite("--- Color Init --- ", _LOG_LINE);
 color7_writeByte(_COLOR7_REG_ENABLE, _COLOR7_ENABLE_RGBC_INTERRUPT |
 _COLOR7_ENABLE_WAIT |
 _COLOR7_ENABLE_RGBC |
 _COLOR7_POWER_ON );

 color7_writeByte(_COLOR7_REG_CONTROL, _COLOR7_CTRL_GAIN_x1);
 color7_writeByte(_COLOR7_REG_RGBC_TIME, _COLOR7_RGBC_TIME_700ms);
 mikrobus_logWrite("--- Start measurement --- ", _LOG_LINE);

 leddriver3_setIntensity(_LEDDRIVER3_CONSTANT | _LEDDRIVER3_INTENSITY_16);
}

void applicationTask()
{
 TFT_Set_Font(&Tahoma12x16_Regular, 0xFFFF, FO_HORIZONTAL);
 TFT_Write_Text(hslData_text, 171, 186);
 colorValue = color7_getColorValue();
 isColor = colorValue;
 colorValue *= 100.00;
 FloatToStr(colorValue, hslData_text);
 TFT_Set_Font(&Tahoma12x16_Regular, 0x0000, FO_HORIZONTAL);
 TFT_Write_Text(hslData_text, 171, 186);

 TFT_Set_Font(&Tahoma12x16_Regular, 0xFFFF, FO_HORIZONTAL);
 TFT_Write_Text(redData_text, 13, 59);
 redRatio = color7_readColorRatio(_COLOR7_COLOR_DATA_RED);
 redRatio *= 100.00;
 FloatToStr(redRatio, redData_text);
 TFT_Set_Font(&Tahoma12x16_Regular, 0x0000, FO_HORIZONTAL);
 TFT_Write_Text(redData_text, 13, 59);

 TFT_Set_Font(&Tahoma12x16_Regular, 0xFFFF, FO_HORIZONTAL);
 TFT_Write_Text(greenData_text, 15, 115);
 greenRatio = color7_readColorRatio(_COLOR7_COLOR_DATA_GREEN);
 greenRatio *= 100.00;
 FloatToStr(greenRatio, greenData_text);
 TFT_Set_Font(&Tahoma12x16_Regular, 0x0000, FO_HORIZONTAL);
 TFT_Write_Text(greenData_text, 15, 115);

 TFT_Set_Font(&Tahoma12x16_Regular, 0xFFFF, FO_HORIZONTAL);
 TFT_Write_Text(blueData_text, 14, 173);
 blueRatio = color7_readColorRatio(_COLOR7_COLOR_DATA_BLUE);
 blueRatio *= 100.00;
 FloatToStr(blueRatio, blueData_text);
 TFT_Set_Font(&Tahoma12x16_Regular, 0x0000, FO_HORIZONTAL);
 TFT_Write_Text(blueData_text, 14, 173);

 if((isColor >= 0.992) && (isColor <= 0.999))
 {
 mikrobus_logWrite("--- Color: ORANGE ", _LOG_LINE);
 DrawCircle(&Color_circle, 0xF000);
 leddriver3_setColor(_LEDDRIVER3_COLOR_ORANGE);
 }
 else if ((isColor >= 0.9750) && (isColor <= 0.9919))
 {
 mikrobus_logWrite("--- Color: RED ", _LOG_LINE);
 DrawCircle(&Color_circle, 0xF800);
 leddriver3_setColor(_LEDDRIVER3_COLOR_RED);
 }
 else if ((isColor >= 0.920) && (isColor <= 0.9749))
 {
 mikrobus_logWrite("--- Color: PINK ", _LOG_LINE);
 DrawCircle(&Color_circle, 0xF00F);
 leddriver3_setRGB_Color(0x5F, 0x60, 0x90);;
 }
 else if ((isColor >= 0.6201) && (isColor <= 0.919))
 {
 mikrobus_logWrite("--- Color: PURPLE ", _LOG_LINE);
 DrawCircle(&Color_circle, 0xF81F);
 leddriver3_setColor(_LEDDRIVER3_COLOR_PURPLE);
 }
 else if ((isColor >= 0.521) && (isColor <= 0.6200))
 {
 mikrobus_logWrite("--- Color: BLUE ", _LOG_LINE);
 DrawCircle(&Color_circle, 0x001F);
 leddriver3_setColor(_LEDDRIVER3_COLOR_BLUE);
 }
 else if ((isColor >= 0.470) && (isColor < 0.520))
 {
 mikrobus_logWrite("--- Color: CYAN ", _LOG_LINE);
 DrawCircle(&Color_circle, 0x07FF);
 leddriver3_setRGB_Color(0x40, 0x7F, 0x9F);
 }
 else if ((isColor >= 0.210) && (isColor <= 0.469))
 {
 mikrobus_logWrite("--- Color: GREEN ", _LOG_LINE);
 DrawCircle(&Color_circle, 0x34C0);
 leddriver3_setColor(_LEDDRIVER3_COLOR_GREEN);
 }
 else if ((isColor >= 0.0650) && (isColor <= 0.180))
 {
 mikrobus_logWrite("--- Color: YELLOW ", _LOG_LINE);
 DrawCircle(&Color_circle, 0xFFE0);
 leddriver3_setColor(_LEDDRIVER3_COLOR_YELLOW);
 }
 else
 {
 mikrobus_logWrite("--- Color: WHITE ", _LOG_LINE);
 DrawCircle(&Color_circle, 0xFFFF);
 leddriver3_setColor(_LEDDRIVER3_COLOR_OFF);
 }
 Delay_ms( 200 );
}

void main()
{
 Start_TP();
 systemInit();
 applicationInit();

 while (1)
 {
 applicationTask();
 }
}
